com.holonplatform.vaadin.components.builders

## Interface InputBuilder<T,C extends Input<T>,B extends InputBuilder<T,C,B>>

- Type Parameters:
    `T` - Value type
    `C` - Input type
    `B` - Concrete builder type
  All Superinterfaces:
    ComponentConfigurator<B>, InputConfigurator<T,B>
  All Known Subinterfaces:
    BaseSelectInputBuilder<T,C,S,ITEM,B>, BaseSelectInputBuilder.MultiSelectConfigurator<T,ITEM,B>, BaseSelectInputBuilder.SingleSelectConfigurator<T,ITEM,B>, BaseSelectModeMultiPropertySelectInputBuilder<T,B>, BaseSelectModeMultiPropertySelectInputBuilder.OptionsModeMultiPropertySelectInputBuilder<T>, BaseSelectModeMultiPropertySelectInputBuilder.SelectModeMultiPropertySelectInputBuilder<T>, BaseSelectModeMultiSelectInputBuilder<T,B>, BaseSelectModeMultiSelectInputBuilder.OptionsModeMultiSelectInputBuilder<T>, BaseSelectModeMultiSelectInputBuilder.SelectModeMultiSelectInputBuilder<T>, BaseSelectModeSinglePropertySelectInputBuilder<T,B>, BaseSelectModeSinglePropertySelectInputBuilder.NativeModeSinglePropertySelectInputBuilder<T>, BaseSelectModeSinglePropertySelectInputBuilder.OptionsModeSinglePropertySelectInputBuilder<T>, BaseSelectModeSinglePropertySelectInputBuilder.SelectModeSinglePropertySelectInputBuilder<T>, BaseSelectModeSingleSelectInputBuilder<T,B>, BaseSelectModeSingleSelectInputBuilder.NativeModeSingleSelectInputBuilder<T>, BaseSelectModeSingleSelectInputBuilder.OptionsModeSingleSelectInputBuilder<T>, BaseSelectModeSingleSelectInputBuilder.SelectModeSingleSelectInputBuilder<T>, BooleanInputBuilder, CalendarInputBuilder<T,B>, DateInputBuilder, MultiPropertySelectInputBuilder<T,B>, MultiPropertySelectInputBuilder.GenericMultiPropertySelectInputBuilder<T>, MultiSelectInputBuilder<T,B>, MultiSelectInputBuilder.GenericMultiSelectInputBuilder<T>, NumberInputBuilder<T>, PropertySelectInputBuilder<T,C,S,B>, SecretInputBuilder, SelectInputBuilder<T,C,S,ITEM,B>, SelectItemDataSourceBuilder<T,C,S,ITEM,B>, SinglePropertySelectInputBuilder<T,B>, SinglePropertySelectInputBuilder.GenericSinglePropertySelectInputBuilder<T>, SingleSelectInputBuilder<T,B>, SingleSelectInputBuilder.GenericSingleSelectInputBuilder<T>, SliderInputBuilder<T>, StringInputBuilder, TemporalInputBuilder<T,B>, TemporalInputBuilder.TemporalWithoutTimeFieldBuilder<T>, TemporalInputBuilder.TemporalWithTimeFieldBuilder<T>, TextInputBuilder<T,C,B>

      public interface InputBuilder<T,C extends Input<T>,B extends InputBuilder<T,C,B>>
      extends InputConfigurator<T,B>

  Builder to create `Input` instances.
  Since:
    5.0.0

- - ### Nested Class Summary

    - ### Nested classes/interfaces inherited from interface com.holonplatform.vaadin.components.builders.InputConfigurator

      `InputConfigurator.BaseFieldConfigurator<T>`

    - ### Nested classes/interfaces inherited from interface com.holonplatform.vaadin.components.builders.ComponentConfigurator

      `ComponentConfigurator.BaseComponentConfigurator`

  - ### Method Summary

    All Methods Instance Methods Abstract Methods
    Modifier and Type | Method and Description
    --- | ---
    `Field<T>` | `asField()` Build the input component as a `HasValue` component.
    `C` | `build()` Build and returns the `Input` instance.
    `B` | `deferLocalization()` Instructs the builder to resolve any message localization (for example component caption and description) only after the component is attached to parent layout.
    `ValidatableInputBuilder<T,ValidatableInput<T>>` | `validatable()` Build a `ValidatableInput` input component.

    - ### Methods inherited from interface com.holonplatform.vaadin.components.builders.InputConfigurator

      `locale, readOnly, tabIndex, withValue, withValueChangeListener`

    - ### Methods inherited from interface com.holonplatform.vaadin.components.builders.ComponentConfigurator

      `caption, caption, caption, captionAsHtml, description, description, description, disabled, errorHandler, fullHeight, fullSize, fullWidth, height, height, heightUndefined, hidden, icon, id, notVisible, primaryStyleName, replaceStyleName, responsive, sizeUndefined, styleName, width, width, widthUndefined, withAttachListener, withContextClickListener, withData, withDetachListener, withShortcutListener`

- - ### Method Detail

    - #### deferLocalization

          B deferLocalization()

      Instructs the builder to resolve any message localization (for example component caption and description) only after the component is attached to parent layout. By default, localization is performed immediately during component building.
      Returns:
        this

    - #### build

          C build()

      Build and returns the `Input` instance.
      Returns:
        the `Input` instance

    - #### validatable

          ValidatableInputBuilder<T,ValidatableInput<T>> validatable()

      Build a `ValidatableInput` input component.
      Returns:
        `ValidatableInput` builder

    - #### asField

          Field<T> asField()

      Build the input component as a `HasValue` component.
      Returns:
        the input `HasValue` instance

Copyright © 2017 The Holon Platform. All rights reserved.